package tgame;
/**
 * This applet demonstrates a simple game. It isn't designed to be general or reusable.
<p>
 * Copyright (C) 2006  <A HREF="http://www.cs.ubc.ca/spider/poole/">David Poole</A>.
<p>
 * This program gives a random environment. The GUI is in <A HREF=TGameGUI.java">TGameGUI.java</A>. The environemnt code is at <A HREF="TGameEnv.java">TGameEnv.java</A>. The controller is at <A HREF="TGameController.java">TGameController.java</A>.
<p>
 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.
<p>
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
<p>
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


 * @author David Poole  poole@cs.ubc.ca
 * @version 0.4 2006-12-04 */
import java.util.ArrayList;
import java.util.Random;

public class TGameEnvRand extends TGameEnv
{
    //   public int currX = 0;  // current X position
    //   public int currY = 2;  // current Y position
    TGameEnv intEnv;
    Random rand;
    int[] internal_to_external_state;
    int[][] acts_map;

    public TGameEnvRand(TGameEnv intEnv,int seed){
	this.intEnv=intEnv;
	rand = new Random((long) seed);
	internal_to_external_state = rperm(6);
	acts_map = new int[6][];
	for (int i=0; i<6; i++)
	    acts_map[i] = rperm(4);
	int int_state = internal_to_external_state[intEnv.currX*yDim+intEnv.currY];
	currX = int_state/yDim;
	currY = int_state%yDim;
        if(datalist.isEmpty()){
            datalist.add(new ArrayList()); 
            data=(ArrayList) datalist.get(0);
            totalnumber.add(0);
        }
    }

    int[] rperm(int n) {
	int[] res = new int[n];
	for (int i=0; i < n; i++)
	    res[i]=i;
	for (int i=1; i < n; i++) {
	    int p = rand.nextInt(i+1);
	    int tmp = res[p];
	    res[p]=res[i];
	    res[i]=tmp;
	}
	for (int i=0; i < n; i++)
	    System.out.print(res[i]+" ");
	System.out.println();
	return res;
    }

    /**
     * does one step.
     *
     * @return reward
     */
    @Override
    public double dostep(int action)  { 
	double rew = intEnv.dostep(acts_map[currX*yDim+currY][action]);
	int int_state = internal_to_external_state[intEnv.currX*yDim+intEnv.currY];
	currX = int_state/yDim;
	currY = int_state%yDim;
	System.out.println("int_state="+int_state+" currX="+currX+" currY="+currY);
	this.reward=intEnv.reward;
	this.numberOfSteps=intEnv.numberOfSteps;
	this.totalReward=intEnv.totalReward;
	this.minReward=intEnv.minReward;
	this.minStep=intEnv.minStep;
	this.zeroCrossing=intEnv.zeroCrossing;
	return rew;
    }
    @Override
    public void doreset(boolean graph) {
	super.doreset(graph);
        intEnv.doreset(graph);
    }
}
