/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package tgame;

import java.applet.Applet;

/**
 * This applet demonstrates a simple grid-world game.  It is complex
 * enough so that simple, rule-based strategies are difficult to
 * write, but it is small enough so that state-based MDP and RL
 * algorihms can work. There are lots of ways it can be extended.
 * It isn't designed to be general or reusable.
 * <P>
 * Copyright (C) 2003-2006  <A HREF="http://www.cs.ubc.ca/spider/poole/">David Poole</A>.
 * <p>
 * This program gives the GUI. The GUI is in <A
 * HREF=SGameGUI.java">SGameGUI.java</A>. The environemnt code is at
 * <A HREF="SGameEnv.java">SGameEnv.java</A>. The controller is at <A
 * HREF="SGameController.java">SGameController.java</A>.
 * <p>
 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.
<p>
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
<p>
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


 * @author David Poole  poole@cs.ubc.ca
 * @version 0.41 2007-09-09 */
public class TGameGUI extends Applet{
     private void getpara()
    {
        controller.alpha=Double.parseDouble(user.settings.alpha.getText());
        controller.alphaFixed=user.settings.fixalpha.isSelected();
        controller.discount=Double.parseDouble(user.settings.discount.getText());
        controller.sarsa=user.head.sarsa.isSelected();
        controller.graph=user.head.graph.isSelected();
        //System.out.println(QControl.graph);
    }
    
    /* This function is used for showing results */
    public void result()
    {
        user.results.lastR.setText(String.format("Last Reward:   %d", (int)environment.reward));
        user.results.totalR.setText(String.format("Total Reward:  %d", (int)environment.totalReward));
        user.results.totalS.setText(String.format("Total Step:     %d", environment.numberOfSteps));
        user.results.minR.setText(String.format("Min Reward:    %d", (int)environment.minReward));
        user.results.minS.setText(String.format("    @Step:      %d", environment.minStep));
        user.results.zeroS.setText(String.format("    @Step:      %d", environment.zeroCrossing));
        validate();
    } 
    
    public void dostep(int action)
    {
        getpara();                                                              //get the newest parameter
        controller.dostep(action);                                                //culculate this step
        PiecesJP.drawpieces();
        result();     
        if(controller.graph&&user.head.graphBox!=null)
            user.head.graphBox.repaint();
        }
    
    public void dosteps(int count, double greedyProb)
    {    
        getpara();                                                              //get parameters
        controller.doSteps(count, greedyProb);                                    //culculate the steps
        PiecesJP.drawpieces();
        result();
        if(controller.graph&&user.head.graphBox!=null)
            user.head.graphBox.repaint();
    }
    
    public void reset(double init)
    {
        controller.doreset(init);
        result();
        PiecesJP.drawpieces();
    }
    @Override
    public void init() {
        //if(getParameter("random").equalsIgnoreCase("True"))
		environment = new TGameEnvRand(new TGameEnv(),12342012);
	//else
            //environment = new TGameEnv();
        
	String whichController = getParameter("controller");
        if(whichController==null) whichController = "QLearning";//For testing
        if (whichController.equalsIgnoreCase("Hand"))
            controller= new TGameController(environment);
	else if (whichController.equalsIgnoreCase("QLearning"))
            controller= new TGameQController(environment);
	else {
		controller= new TGameController(environment);
		System.out.println("Unknown Controller: "+whichController+" in TGame.");
	}
        
// 		else if (whichController.equalsIgnoreCase("FunctionApproximation"))
// 			controller= new TGameFAController();
// 		else if (whichController.equalsIgnoreCase("Adversary"))
// 			controller= new TGameAdvController();
		
        PiecesJP = new TGamePieces(3, 2);
        user = new tgame.TGameUser();

        user.setName("user"); 
        user.getpara(this);
        
        setLayout(new javax.swing.BoxLayout(this, javax.swing.BoxLayout.X_AXIS));
        add(PiecesJP);
        add(user);
    }
              
    public TGamePieces PiecesJP;
    public tgame.TGameUser user;
    TGameController controller;
    public final int Up=0;
    public final int Left=3;
    public final int Right=1;
    public final int CarefulUp=2;
    
    public class TGamePieces extends javax.swing.JPanel {
           
        /** Creates new form TGamePieces */
        public TGamePieces(int x, int y) {
            xDim=x;
            yDim=y;
            initComponents();
            pieces=new TGamePiece[xDim][yDim];
            int i, j;
            for(i=0 ; i<xDim ; i++){
                for(j=0 ; j<yDim ; j++){
                    if(pieces[i][j]==null){
                        pieces[i][j]=new tgame.TGamePiece();
                    }
                    add(pieces[i][j]);
                }
            }
            drawpieces();
        }
    
        final void drawpieces(){
            int i, j;
            double maxq;
            for(i=0 ; i<xDim ; i++){
                for(j=0 ; j<yDim ; j++){
                    maxq=controller.qvalue(j, i,0);
                    for (int t=1; t<4 ;t++) {
                        if (maxq < controller.qvalue(j, i, t))
                            maxq = controller.qvalue(j, i, t);
                    }
                    pieces[i][j].up.setText(String.format("%.2f", controller.qvalue(j, i, Up))); 
                    pieces[i][j].left.setText(String.format("%.2f", controller.qvalue(j, i, Left))); 
                    pieces[i][j].right.setText(String.format("%.2f", controller.qvalue(j, i, Right))); 
                    pieces[i][j].upC.setText(String.format("%.2f", controller.qvalue(j, i, CarefulUp))); 
                    if(controller.qvalue(j, i, Up)<maxq) pieces[i][j].up.setIcon(null);
                    else pieces[i][j].up.setIcon(new javax.swing.ImageIcon(getClass().getResource("/tgame/resources/arrow-u2.png")));
                    if(controller.qvalue(j, i, Left)<maxq) pieces[i][j].left.setIcon(null);
                    else pieces[i][j].left.setIcon(new javax.swing.ImageIcon(getClass().getResource("/tgame/resources/arrow-l2.png")));
                    if(controller.qvalue(j, i, Right)<maxq) pieces[i][j].right.setIcon(null);
                    else pieces[i][j].right.setIcon(new javax.swing.ImageIcon(getClass().getResource("/tgame/resources/arrow-r2.png")));
                    if(controller.qvalue(j, i, CarefulUp)<maxq) pieces[i][j].upC.setIcon(null);
                    else pieces[i][j].upC.setIcon(new javax.swing.ImageIcon(getClass().getResource("/tgame/resources/arrow-cu2.png")));
                    pieces[i][j].head.setIcon(null);
                }                                     
            }
            int currX=controller.environment.currX;
            int currY=controller.environment.currY;
            pieces[currY][currX].head.setIcon(new javax.swing.ImageIcon(getClass().getResource("/tgame/resources/head.png")));
            validate();
        }                 
        
        public void changeFont(String type)
        {
            int i, j;
            for(i=0 ; i<xDim ; i++)
                for(j=0 ; j<yDim ; j++)
                    pieces[i][j].changeFont(type);
        }
        
        private void initComponents() {
            setPreferredSize(new java.awt.Dimension(sqsize*yDim, sqsize*xDim));
            setLayout(new java.awt.GridLayout(xDim, yDim, 10, 3));
        }                
        public TGamePiece pieces[][];
        public int xDim;
        public int yDim;
        public int sqsize = 225;
    }
    TGameEnv environment;
}
